#include <QtGui>
#include <bundleWidget.h>
#include <readFile.h>


BundleWidget::BundleWidget(QWidget *parent)
        : QWidget(parent)
{
#ifdef PDAGUI
//	setFixedSize(230, 300);
#else
	setFixedSize(990, 660);
#endif //PDAGUI
	
	ReadFile conf;

#ifndef PDAGUI
	//List group
	QGroupBox *bundleBox = new QGroupBox("Bundle list");
#endif //PDAGUI

	//Bundle table
	table = new QTableWidget(200, 9, this);
    QStringList horizontalLabels;
    horizontalLabels << "ID" << "TimeStamp" << "SrcStr" << "DestStr"<< "Source" << "Dest" << "Data" << "Options" << "Size";
	table->setHorizontalHeaderLabels(horizontalLabels); 


	//Final grid layout
    QGridLayout *bundleGroup = new QGridLayout;
	bundleGroup->addWidget(table, 0, 0);
#ifdef PDAGUI
	bundleGroup->setMargin(0);
	bundleGroup->setSpacing(0);
//	bundleBox->setFixedSize(230, 270);
#else
	bundleBox->setFixedSize(950, 550);
	bundleBox->setLayout(bundleGroup);
#endif //PDAGUI

#ifndef PDAGUI
	QGroupBox *buttonBox = new QGroupBox("Administration");
#endif //PDAGUI
#ifdef PDAGUI
	removeSelected = new QPushButton("Remove Selected");
	removeAll = new QPushButton("Remove All");
#else
	removeSelected = new QPushButton("Remove Selected One");
	removeAll = new QPushButton("Remove All Bundles");
#endif //PDAGUI
	connect(removeSelected, SIGNAL(pressed()), this, SLOT(removeSelectedSlot()));
	connect(removeAll, SIGNAL(pressed()), this, SLOT(removeAllSlot()));


	//Final grid layout
    QGridLayout *administrationGroup = new QGridLayout;

	administrationGroup->addWidget(removeSelected, 0, 0);
	administrationGroup->addWidget(removeAll, 0, 1);

#ifdef PDAGUI
	administrationGroup->setMargin(0);
	administrationGroup->setSpacing(0);
// 	buttonBox->setFixedSize(230, 30);
//	buttonBox->setLayout(administrationGroup);
	//Define final layout
	QVBoxLayout *layout = new QVBoxLayout;
	layout->setMargin(0);
	layout->setSpacing(0);
	QWidget *tempWidget1 = new QWidget(this);
//	table->setFixedSize(230,260);
//	tempWidget1->setFixedSize(230,260);
	tempWidget1->setLayout(bundleGroup);
    layout->addWidget(tempWidget1);
	QWidget *tempWidget2 = new QWidget(this);
//	tempWidget2->setFixedSize(230,40);
	tempWidget2->setLayout(administrationGroup);
	layout->addWidget(tempWidget2);
    setLayout(layout);
#else
 	buttonBox->setFixedSize(950, 60);
	buttonBox->setLayout(administrationGroup);
	//Define final layout
	QVBoxLayout *layout = new QVBoxLayout;
    layout->addWidget(bundleBox);    
	layout->addWidget(buttonBox);    
    setLayout(layout);
#endif //PDAGUI
}


void BundleWidget::removeSelectedSlot()
{

	QList<QTableWidgetItem*> list; 
	list = table->selectedItems ();
	if(list.size()==1)
	for (int i = 0; i < list.size(); ++i) 
	{
		QTableWidgetItem* item = list[i];
		int bundleId = item->text().toInt(0,10);
		emit removeBundle(bundleId);
	}
}

void BundleWidget::removeAllSlot()
{
	 if(
	QMessageBox::question(
		this,
		 "Warning",
		"Are you really sure to remove all bundles?\n",
		"No","Yes",
		QString(),1,0)
	  )
		emit removeAllBundles();
}

void BundleWidget::getBundleList(QList<Bundle> list)
{
	Bundle newBundle;
	table->clear();
	QStringList horizontalLabels;
    horizontalLabels << "ID" << "TimeStamp" << "SrcStr" << "DestStr"<< "Source" << "Dest" << "Data" << "Options" << "Size";
	table->setHorizontalHeaderLabels(horizontalLabels);
	table->setColumnWidth(0, 70);	//ID
	table->setColumnWidth(2, 70);	//time
	table->setColumnWidth(3, 70);	//srcstr
	table->setColumnWidth(4, 70);	//dststr
	table->setColumnWidth(5, 30);	//src
	table->setColumnWidth(6, 30);	//dst
	table->setColumnWidth(7, 70);	//data
	table->setColumnWidth(8, 40);	//opt
	table->setColumnWidth(9, 40);	//size
   for (int i = 0; i < list.size(); ++i) 
	{
		newBundle=list.at(i);
		QString text = QString("%1").arg((int)newBundle.getId());
		QTableWidgetItem *newItem = new QTableWidgetItem(text);
		table->setItem(i, 0, newItem);
	
		QDateTime time= newBundle.getTime();
		text = time.toString("MM/dd/yyyy hh:mm:ss");
		newItem = new QTableWidgetItem(text);
		table->setItem(i, 1, newItem);

	
		newItem = new QTableWidgetItem((QString)newBundle.sourceString);
		table->setItem(i, 2, newItem);
		
		newItem = new QTableWidgetItem((QString)newBundle.destinationString);
		table->setItem(i, 3, newItem);
		
		text = QString("%1").arg((int)newBundle.getSourceId());
		newItem = new QTableWidgetItem(text);
		table->setItem(i, 4, newItem);

		text = QString("%1").arg((int)newBundle.getDestinationId());
		newItem = new QTableWidgetItem(text);
		table->setItem(i, 5, newItem);
	
		newItem = new QTableWidgetItem((QString)newBundle.getData());
		table->setItem(i, 6, newItem);

		text = QString("%1").arg((int)newBundle.getOptions());
		newItem = new QTableWidgetItem(text);
		table->setItem(i, 7, newItem);

		text = QString("%1").arg((int)newBundle.dataLength);
		newItem = new QTableWidgetItem(text);
		table->setItem(i, 8, newItem);


	}

 }
