#ifndef DEBUGWIDGET_H
#define DEBUGWIDGET_H


#include <QtGui>
#include <bundle.h>
#include <node.h>
#include <connectionWidget.h>
#include <msgWidget.h>
#include <msgReadWidget.h>
#include <configWidget.h>
#include <infoWidget.h>
#include <bundleWidget.h>
#include <neighbourAwareness.h>
#include <bundleManager.h>

class DebugWidget : public QWidget
{
	Q_OBJECT 

	public:
		DebugWidget(NodeManager*,BundleManager*,QWidget *parent = 0);
		QTableWidget *table;
		QTableWidget *nodeTable;
		QTableWidget *conTable;
		ConnectionWidget *connectionWidget;
		MsgWidget *message;
		MsgReadWidget *messageRead;
		ConfigWidget *configWidget;
		QTabWidget *tabWidget;
		QListWidget *info;
		QTextEdit *dtnInfo;
		InfoWidget *infoWidget;
		BundleWidget *bundleWidget;
		BundleManager *bundleManager;	
	int dtnEntery;
	 signals:
		void sendAppBundle(Bundle);
		void traffic(int);
		void newConnectionStatus(int);
		void newConnection(int);
		void newRemovedConnection(int);
		void usedFileStorage(int);
		void usedMemoryStorage(int);
		void sendBundleList(QList<Bundle>);
		void forwardConnectionList(QList <ConnectionInfo>);
		void removeBundle(int);
		void removeAllBundles();

	public slots:
	void getLog(QString);
	void getStorageSize(int);
	void getConnectionList(QList<ConnectionInfo> list);
	void getBundleList(QList<Bundle>);
	void forwardAppBundle(Bundle);
	void getAppBundle(Bundle);
	void getNodeList(QList<Node>);

	void getTraffic(int);
	void getNewConnection(int);
	void getNewConnectionStatus(int);
	void getRemovedConnection(int);
	void getUsedFileStorage(int);
	void getUsedMemoryStorage(int);
	void removeBundleSlot(int);
	void removeAllBundlesSlot();


};

#endif


