#ifndef TCPCLIENT_H
#define TCPCLIENT_H

#include <QtCore>
#include <QTcpSocket>
#include <QTextCodec>

class TcpClient : public QTcpSocket
{
	Q_OBJECT

public:
	TcpClient(QObject* parent = 0);
	~TcpClient();
	virtual void addHost(QString hn, int hp);
	virtual void appendCommand(int id, QString cmd);
	virtual bool isConnected();

public slots:
	virtual void reconnectToHost();
	virtual void hostStateChanged(QAbstractSocket::SocketState state);
	virtual void hostError(QAbstractSocket::SocketError error);
	virtual void hostReadyRead();

signals:
	void newAnswer(QByteArray answ);
	void connected();
	void disconnected();
	
private:
	QList<QString> commands;
	QList<int> ids;
	QByteArray buffer;
	QTimer* timer;
	QList<QString> hostNames;
	QList<int> hostPorts;
	int currentHostIndex;
};

#endif
